using System;
using System.Collections.Generic;
using System.Text;
using Zcu.Mve.Core;
using Zcu.Mve.Visualization;
using Zcu.Mve.Numerics;

namespace Zcu.Mve.Visualization
{
    class CoordinateAdder:Module
    {
        public CoordinateAdder()
        {
            AddInPort("Point", typeof(IPoint));
            AddInPort("New Coordinate", typeof(Scalar));
            AddOutPort("Enlarged Point", typeof(PointND));
        }

        private PointND result;

        public override void Execute()
        {
            if (!IsAllDataSame() || (result == null))
            {
                IPoint inpoint = (IPoint)GetInput("Point");
                result = new PointND(inpoint.Length+1);
                for (int i = 0; i < inpoint.Length; i++)
                {
                    result[i] = inpoint[i];
                }
                Scalar v = (Scalar)GetInput("New Coordinate");
                result[result.Length - 1] = v.Value;
                SetOutput("Enlarged Point", result);
            }
            else
            {
                SetOutput("Enlarged Point", result);
            }
        }
    }
}
