using System;
using System.Drawing;
using System.Data;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Zcu.Mve.Visualization
{
	/// <summary>
	/// Panel for data view.
	/// </summary>
	public class CurveRendererDataView : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Data.DataSet dataSet1;
		private System.Data.DataTable dataTable1;
		private System.Data.DataColumn dataColumn1;
		private System.Data.DataColumn dataColumn2;
		private System.Data.DataColumn dataColumn3;
		private System.Windows.Forms.DataGrid dataGrid1;
		private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn2;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn3;

		/// <summary> Renderer panel object. </summary>
		private CurveRendererPanel panel;

		/// <summary>
		/// Creates the form.
		/// </summary>
		/// <param name="rendererPanel">Renderer panel.</param>
		public CurveRendererDataView(CurveRendererPanel rendererPanel)
		{
			this.panel = rendererPanel;
			this.panel.highlightProgress = true;
			this.panel.highlightedPointIndex = 0;
			this.panel.Refresh();
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// add all point into dataTable
			for (int i = 0; i < rendererPanel.renderer.data.Count; i++)
			{
				Point2D currentPoint = (Point2D) rendererPanel.renderer.data[i];
				DataRow newRow = this.dataTable1.NewRow();
				newRow[0] = i;
				newRow[1] = currentPoint.X;
				newRow[2] = currentPoint.Y;
				this.dataTable1.Rows.Add(newRow);
			}
			this.dataGrid1.CurrentCellChanged += new System.EventHandler(this.DataGridCurrentCellChanged);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				this.panel.highlightProgress = false;
				this.panel.Refresh();
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataSet1 = new System.Data.DataSet();
			this.dataTable1 = new System.Data.DataTable();
			this.dataColumn1 = new System.Data.DataColumn();
			this.dataColumn2 = new System.Data.DataColumn();
			this.dataColumn3 = new System.Data.DataColumn();
			this.dataGrid1 = new System.Windows.Forms.DataGrid();
			this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
			this.dataGridTextBoxColumn1 = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dataGridTextBoxColumn2 = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dataGridTextBoxColumn3 = new System.Windows.Forms.DataGridTextBoxColumn();
			((System.ComponentModel.ISupportInitialize)(this.dataSet1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataTable1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// dataSet1
			// 
			this.dataSet1.DataSetName = "NewDataSet";
			this.dataSet1.Locale = new System.Globalization.CultureInfo("cs-CZ");
			this.dataSet1.Tables.AddRange(new System.Data.DataTable[] {
																		  this.dataTable1});
			// 
			// dataTable1
			// 
			this.dataTable1.Columns.AddRange(new System.Data.DataColumn[] {
																			  this.dataColumn1,
																			  this.dataColumn2,
																			  this.dataColumn3});
			this.dataTable1.TableName = "Table1";
			// 
			// dataColumn1
			// 
			this.dataColumn1.Caption = "Point id";
			this.dataColumn1.ColumnName = "Point id";
			this.dataColumn1.DataType = typeof(int);
			// 
			// dataColumn2
			// 
			this.dataColumn2.Caption = "X";
			this.dataColumn2.ColumnName = "X";
			this.dataColumn2.DataType = typeof(System.Double);
			// 
			// dataColumn3
			// 
			this.dataColumn3.Caption = "Y";
			this.dataColumn3.ColumnName = "Y";
			this.dataColumn3.DataType = typeof(System.Double);
			// 
			// dataGrid1
			// 
			this.dataGrid1.AllowNavigation = false;
			this.dataGrid1.CaptionVisible = false;
			this.dataGrid1.DataMember = "Table1";
			this.dataGrid1.DataSource = this.dataSet1;
			this.dataGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid1.Location = new System.Drawing.Point(5, 5);
			this.dataGrid1.Name = "dataGrid1";
			this.dataGrid1.ReadOnly = true;
			this.dataGrid1.RowHeadersVisible = false;
			this.dataGrid1.Size = new System.Drawing.Size(198, 212);
			this.dataGrid1.TabIndex = 0;
			this.dataGrid1.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																								  this.dataGridTableStyle1});
			this.dataGrid1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.dataGrid1_KeyDown);
			// 
			// dataGridTableStyle1
			// 
			this.dataGridTableStyle1.DataGrid = this.dataGrid1;
			this.dataGridTableStyle1.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																												  this.dataGridTextBoxColumn1,
																												  this.dataGridTextBoxColumn2,
																												  this.dataGridTextBoxColumn3});
			this.dataGridTableStyle1.HeaderFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.dataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTableStyle1.MappingName = "Table1";
			this.dataGridTableStyle1.ReadOnly = true;
			this.dataGridTableStyle1.RowHeadersVisible = false;
			// 
			// dataGridTextBoxColumn1
			// 
			this.dataGridTextBoxColumn1.Format = "";
			this.dataGridTextBoxColumn1.FormatInfo = null;
			this.dataGridTextBoxColumn1.HeaderText = "index";
			this.dataGridTextBoxColumn1.MappingName = "Point id";
			this.dataGridTextBoxColumn1.Width = 50;
			// 
			// dataGridTextBoxColumn2
			// 
			this.dataGridTextBoxColumn2.Format = "";
			this.dataGridTextBoxColumn2.FormatInfo = null;
			this.dataGridTextBoxColumn2.HeaderText = "x";
			this.dataGridTextBoxColumn2.MappingName = "X";
			this.dataGridTextBoxColumn2.Width = 72;
			// 
			// dataGridTextBoxColumn3
			// 
			this.dataGridTextBoxColumn3.Format = "";
			this.dataGridTextBoxColumn3.FormatInfo = null;
			this.dataGridTextBoxColumn3.HeaderText = "y";
			this.dataGridTextBoxColumn3.MappingName = "Y";
			this.dataGridTextBoxColumn3.Width = 72;
			// 
			// CurveRendererDataView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(208, 222);
			this.Controls.Add(this.dataGrid1);
			this.DockPadding.All = 5;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.KeyPreview = true;
			this.Name = "CurveRendererDataView";
			this.Text = "CurveRendererDataView";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.CurveRendererDataView_KeyDown);
			((System.ComponentModel.ISupportInitialize)(this.dataSet1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataTable1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		#region Event handling

		/// <summary>
		/// Close the form if 'Escape' was pressed.
		/// </summary>
		/// <param name="e"></param>
		private void KbdEscape(KeyEventArgs e)
		{
			if (e.KeyData  == Keys.Escape)
				this.Close();
		}

		private void CurveRendererDataView_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			KbdEscape(e);
		}

		private void dataGrid1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			KbdEscape(e);
		}

		/// <summary>
		/// Event 'current cell changed' occurred.
		/// </summary>
		private void DataGridCurrentCellChanged(object sender, System.EventArgs e)
		{
			if (panel.renderer.allowHighlighting)
			{
				int pointId = (int) this.dataGrid1[this.dataGrid1.CurrentCell.RowNumber, 0];
				this.panel.highlightedPointIndex = pointId;
				this.panel.Refresh();
			}
		}

		#endregion


	} // class
} // namespace
