using System;

namespace Zcu.Mve.Visualization
{
	/// <summary>
	/// Specialization of Mesh. Can contain only TriangleStrip cells.
	/// Attributes are not limited.
	/// </summary>
	public class TriangleStripMesh : Zcu.Mve.Visualization.Mesh
	{
		/// <summary>
		/// Create empty StripMesh. Eigen cell is TriangleStrip only.
		/// </summary>
		public TriangleStripMesh()
		{
			eigCells.Clear();
			eigCells.Add(typeof(TriangleStrip), null);
		}

		/// <summary>
		/// Returns TrinagleStrip from array named "TriangleStrip".
		/// </summary>
		/// <param name="index">Index of the TriangleStrip.</param>
		/// <returns>TriangleStrip with given index.</returns>
		public TriangleStrip GetTriangleStrip(int index)
		{
			return (TriangleStrip) GetCells("TriangleStrip")[index];
		}

		/// <summary>
		/// Returns number of triangle strips. (Number of elements in field named "TriangleStrip")
		/// </summary>
		/// <returns>Number of TriangleStrips.</returns>
		public int GetNTriangleStrips()
		{
			return GetCells("TriangleStrip").Count;
		}

	} // class StripMesh
} // namespace