using System;
using System.Collections;
using System.Xml;
using Zcu.Mve.Core;

namespace Zcu.Mve.Visualization
{
	/// <summary>
	/// This class represents two dimensional static array of one specific DataObject.
	/// </summary>
	public class UniformDataArray2D : MveArray
	{
		/// <summary>
		/// For XmlLoader use only. Use parametric constructor instead.
		/// </summary>
		public UniformDataArray2D()
		{
		}    

		/// <summary>
		/// Creates empty 2D array of given type.
		/// </summary>
		/// <param name="height">Number of lines</param>
		/// <param name="width">Number of columns</param>
		/// <param name="type">The only accepted type</param>
		public UniformDataArray2D(Type type, int height, int width) : base (type, height, width)
		{
		}

		/// <summary>
		/// Returns width of curent data array.
		/// </summary>
		public int Width
		{
			get
			{
				return this.Lengths[1];
			}
		}

		/// <summary>
		/// Returns height of curent data array.
		/// </summary>
		public int Height
		{
			get
			{
				return this.Lengths[0];
			}
		}

	}
}
